var isBanner = false;
function adMobCall(t) {
    initApp(t);
}
var ad_units = {
    android: {
        banner: 'ca-app-pub-9289025252701782/7654377751',
        interstitial: 'ca-app-pub-9289025252701782/9722233358'
    }, ios: {
        banner: 'ca-app-pub-9289025252701782/7654377751',
        interstitial: 'ca-app-pub-9289025252701782/9722233358'
    }
};
var admobid = ( /(android)/i.test(navigator.userAgent) ) ? ad_units.android : ad_units.ios;

var refreshBanner = function () {
    isBanner = false;
    AdMob.createBanner({
        adId: admobid.banner,
        autoShow: false,
        position: AdMob.AD_POSITION.BOTTOM_CENTER,
        success: function () {
        },
        error: function () {
        }
    });
};

function initApp(t) {
    if (!AdMob) {
        return;
    }
    initAd(t);
    refreshBanner();
    AdMob.prepareInterstitial({
        adId: admobid.interstitial,
        autoShow: false
    });
}
function initAd(t) {
    var defaultOptions = {
        bannerId: admobid.banner,
        interstitialAdId: admobid.interstitial,
//        adSize: 'SMART_BANNER',
//        width: integer, // valid when set adSize 'CUSTOM'
//        height: integer, // valid when set adSize 'CUSTOM'
        position: AdMob.AD_POSITION.BOTTOM_CENTER,
//        x: integer,		// valid when set position to 0 / POS_XY
//        y: integer,		// valid when set position to 0 / POS_XY
        isTesting: false, // set to true, to receiving test ad for testing purpose
        autoShow: false // auto show interstitial ad when loaded, set to false if prepare/show
    };
    AdMob.setOptions(defaultOptions);
    registerAdEvents();
}
// optional, in case respond to events or handle error
function registerAdEvents() {
    document.addEventListener('onBannerFailedToReceive', function () {
        isBanner = false;
        refreshBanner();
    });
    document.addEventListener('onBannerReceive', function () {
        isBanner = true;
        AdMob.showBanner();
    });
    document.addEventListener('onBannerPresent', function () {
    });
    document.addEventListener('onBannerLeaveApp', function () {
    });
    document.addEventListener('onBannerDismiss', function () {
        AdMob.removeBanner();
        setTimeout(function () {
            refreshBanner();
        }, 5000);
    });

    document.addEventListener('onInterstitialFailedToReceive', function () {
        AdMob.prepareInterstitial({
            adId: admobid.interstitial,
            autoShow: false
        });
    });
    document.addEventListener('onInterstitialReceive', function () {
    });
    document.addEventListener('onInterstitialPresent', function () {
        quitAppNow();
    });
    document.addEventListener('onInterstitialLeaveApp', function () {
        quitAppNow();
    });
    document.addEventListener('onInterstitialDismiss', function () {
        quitAppNow();
    });
}