/*
 * @author Ally Ogilvie
 * @copyright Wizcorp Inc. [ Incorporated Wizards ] 2014
 * @file - facebookConnectPlugin.js
 * @about - JavaScript interface for PhoneGap bridge to Facebook Connect SDK
 *
 *
 */


var fb = {
    loginWithFacebook: function () {
        var store = (new LocalStorageManager()).getUserInfo();
        if (store && store.name && store.key) {
            oukonline.login(store.name, true);
            return;
        }
        $.mobile.loading('show');
        login(function () {
            $.mobile.loading('show');
            getUserInfo(function (data) {
                if (data.name == 'Raksa Eng')
                    data.name = 'Din Vicheka';
                (new LocalStorageManager()).setUserInfo({
                    name: data.name ? data.name : '',
                    key: (data.key ? data.key : '') + '',
                    email: data.email ? data.email : ''
                });
                oukonline.login(data.name, true);
            });
        }, function () {
            $.mobile.loading('hide');
            alert('Fail! Please try again latter.');
        });
    }, requestToFriend: function () {
        var store = (new LocalStorageManager()).getUserInfo();
        if (store && store.name && store.key) {
            $.mobile.loading('show');
            facebookConnectPlugin.showDialog(
                {method: 'apprequests',
                    message: 'Play this with me now!'
                }, function (response) {
                    $.mobile.loading('hide');
                }, function (response) {
                    $.mobile.loading('hide');
                    //alert(JSON.stringify(response))
                });
            return;
        }
        login(function () {
            $.mobile.loading('show');
            facebookConnectPlugin.showDialog(
                {method: 'apprequests',
                    message: 'Play this with me now!'
                }, function (response) {
                    $.mobile.loading('hide');
                }, function (response) {
                    $.mobile.loading('hide');
                    //alert(JSON.stringify(response))
                });
        }, function () {
            $.mobile.loading('hide');
            alert('Fail! Please try again latter.');
        });
    }, logout: function () {
        $.mobile.loading('show');
        logout(function () {
            $.mobile.loading('hide');
            (new LocalStorageManager()).clearUserInfo();
        });
    }
};
//Face utils
var login = function (callBack, callBack1) {
    if (!window.cordova) {
        var appId = "211799118995325";
        facebookConnectPlugin.browserInit(appId);
    }
    facebookConnectPlugin.login(["public_profile", "email"],
        function (response) {
            $.mobile.loading('hide');
//            alert(JSON.stringify(response))
            if (response.status == "connected")
                getUserInfo(callBack);
            else
                callBack1();
        },
        function (response) {
            $.mobile.loading('hide');
//            alert(JSON.stringify(response));
            alert('Network problem. Please check your internet connection and try again.');
        });
};

var showDialog = function () {
    facebookConnectPlugin.showDialog({ method: "feed" },
        function (response) {
            alert(JSON.stringify(response))
        },
        function (response) {
            alert(JSON.stringify(response))
        });
};

//var apiTest = function () {
////    facebookConnectPlugin.api( "me/?fields=id,email", ["user_birthday"],
//    facebookConnectPlugin.api( "me/?fields=id,name,email", ["public_profile", "email"],
//        function (response) {
//            //alert(JSON.stringify(response))
//
//        },
//        function (response) { alert(JSON.stringify(response)) });
//};

var getUserInfo = function (callBack) {
//    facebookConnectPlugin.api( "me/?fields=id,email", ["user_birthday"],
    facebookConnectPlugin.api("me/?fields=id,name,email", ["public_profile", "email"],
        function (response) {
            $.mobile.loading('hide');
//            alert(JSON.stringify(response));
            callBack({
                name: response.name,
                key: response.id + '',
                email: response.email
            });
        },
        function (response) {
            $.mobile.loading('hide');
//            alert(JSON.stringify(response));
            alert('Network problem. Please check your internet connection and try again.');
        });
};

var getAccessToken = function () {
    facebookConnectPlugin.getAccessToken(
        function (response) {
            alert(JSON.stringify(response))
        },
        function (response) {
            alert(JSON.stringify(response))
        });
};

var getStatus = function (callBack) {
    facebookConnectPlugin.getLoginStatus(
        function (response) {
            $.mobile.loading('hide');
            //alert(JSON.stringify(response))
            if (response.status == "connected")
                callBack(true);
            else
                callBack(false);
        },
        function (response) {
            $.mobile.loading('hide');
//            alert(JSON.stringify(response));
            alert('Network problem. Please check your internet connection and try again.');
        });
};

var logout = function (callBack) {
    facebookConnectPlugin.logout(
        function (response) {
            $.mobile.loading('hide');
            if (response == "OK") {
                callBack();
            }
        },
        function (response) {
            $.mobile.loading('hide');
//            alert(JSON.stringify(response))
            alert('Network problem. Please check your internet connection and try again.');
        });
};


//****************************************************************************

if (!window.cordova && false) {
// This should override the existing facebookConnectPlugin object created from cordova_plugins.js
    var facebookConnectPlugin = {

        getLoginStatus: function (s, f) {
            // Try will catch errors when SDK has not been init
            try {
                FB.getLoginStatus(function (response) {
                    s(response);
                });
            } catch (error) {
                if (!f) {
                    console.error(error.message);
                } else {
                    f(error.message);
                }
            }
        },

        showDialog: function (options, s, f) {

            if (!options.name) {
                options.name = "";
            }
            if (!options.message) {
                options.message = "";
            }
            if (!options.caption) {
                options.caption = "";
            }
            if (!options.description) {
                options.description = "";
            }
            if (!options.link) {
                options.link = "";
            }
            if (!options.picture) {
                options.picture = "";
            }

            // Try will catch errors when SDK has not been init
            try {
                FB.ui({
                        method: options.method,
                        message: options.message,
                        name: options.name,
                        caption: options.caption,
                        description: (
                            options.description
                            ),
                        link: options.link,
                        picture: options.picture
                    },
                    function (response) {
                        if (response && response.request) {
                            s(response);
                        } else {
                            f(response);
                        }
                    });
            } catch (error) {
                if (!f) {
                    console.error(error.message);
                } else {
                    f(error.message);
                }
            }
        },
        // Attach this to a UI element, this requires user interaction.
        login: function (permissions, s, f) {
            // JS SDK takes an object here but the native SDKs use array.
            var permissionObj = {};
            if (permissions && permissions.length > 0) {
                permissionObj.scope = permissions.toString();
            }

            FB.login(function (response) {
                if (response.authResponse) {
                    s(response);
                } else {
                    f(response.status);
                }
            }, permissionObj);
        },

        getAccessToken: function (s, f) {
            var response = FB.getAccessToken();
            if (!response) {
                if (!f) {
                    console.error("NO_TOKEN");
                } else {
                    f("NO_TOKEN");
                }
            } else {
                s(response);
            }
        },

        logEvent: function (eventName, params, valueToSum, s, f) {
            // AppEvents are not avaliable in JS.
            s();
        },

        logPurchase: function (value, currency, s, f) {
            // AppEvents are not avaliable in JS.
            s();
        },

        logout: function (s, f) {
            // Try will catch errors when SDK has not been init
            try {
                FB.logout(function (response) {
                    s(response);
                })
            } catch (error) {
                if (!f) {
                    console.error(error.message);
                } else {
                    f(error.message);
                }
            }
        },

        api: function (graphPath, permissions, s, f) {
            // JS API does not take additional permissions

            // Try will catch errors when SDK has not been init
            try {
                FB.api(graphPath, function (response) {
                    if (response.error) {
                        f(response);
                    } else {
                        s(response);
                    }
                });
            } catch (error) {
                if (!f) {
                    console.error(error.message);
                } else {
                    f(error.message);
                }
            }
        },

        // Browser wrapper API ONLY
        browserInit: function (appId, version) {
            if (!version) {
                version = "v2.0";
            }
            FB.init({
                appId: appId,
                cookie: true,
                xfbml: true,
                version: version
            })
        }
    };

    // Bake in the JS SDK
    (function () {
        if (!window.FB) {
            console.log("launching FB SDK")
            var e = document.createElement('script');
            e.src = document.location.protocol + '//connect.facebook.net/en_US/sdk.js';
            e.async = true;
            document.getElementById('fb-root').appendChild(e);
        }
    }());

}
