window.fakeStorage = {
    _data: {},

    setItem: function (id, val) {
        return this._data[id] = String(val);
    },

    getItem: function (id) {
        return this._data.hasOwnProperty(id) ? this._data[id] : undefined;
    },

    removeItem: function (id) {
        return delete this._data[id];
    },

    clear: function () {
        return this._data = {};
    }
};

function LocalStorageManager() {
    this.userInfo = "userInfo";
    this.userSetting = "userSetting";

    var supported = this.localStorageSupported();
    this.storage = supported ? window.localStorage : window.fakeStorage;
}

LocalStorageManager.prototype.localStorageSupported = function () {
    var testKey = "test";
    var storage = window.localStorage;

    try {
        storage.setItem(testKey, "1");
        storage.removeItem(testKey);
        return true;
    } catch (error) {
        return false;
    }
};

// Raksa use session
LocalStorageManager.prototype.setUserInfo = function (data) {
    this.storage.setItem(this.userInfo, JSON.stringify(data));
};
LocalStorageManager.prototype.getUserInfo = function () {
    var data = this.storage.getItem(this.userInfo);
    return data ? JSON.parse(data) : null;
};
LocalStorageManager.prototype.clearUserInfo = function () {
    this.storage.removeItem(this.userInfo);
};// Raksa use setting
LocalStorageManager.prototype.setUserSetting = function (data) {
    this.storage.setItem(this.userSetting, JSON.stringify(data));
};
LocalStorageManager.prototype.getUserSetting = function () {
    var data = this.storage.getItem(this.userSetting);
    return data ? JSON.parse(data) : {guide:true, sound:true};
};
LocalStorageManager.prototype.clearUserSetting = function () {
    this.storage.removeItem(this.userSetting);
};