//Make caret position getter
(function ($) {
    $.fn.getCursorPosition = function () {
        var input = this.get(0);
        if (!input) return; // No (input) element found
        if ('selectionStart' in input) {
            // Standard-compliant browsers
            return input.selectionStart;
        } else if (document.selection) {
            // IE
            input.focus();
            var sel = document.selection.createRange();
            var selLen = document.selection.createRange().text.length;
            sel.moveStart('character', -input.value.length);
            return sel.text.length - selLen;
        }
    }
})(jQuery);

var mobile = mobile = !!(new MobileDetect(window.navigator.userAgent)).mobile();
var jqueryChangePageStyle = ['slide', 'slideup', 'slidedown', 'pop', 'fade', 'flip'];
var CONTEXT = {
    user: "",
    key: "",
    history: [],
    currentHistoryIndex: 0,
    currentGameName: 'Rek Online'
};
var thistimeout;
var thistitleTimerId;
var thiscurrentGameName = "";
var msnotify = "";
$(document).ready(function () {
    //Initialize
    Init();
    oukonline.info('login_returnmessage');
    $('#login_username').focus();
    $('#boardpage').on('pageshow', function (event) {
        checkContext();
    });
    $('#mainpage').on('pageshow', function (event) {
        checkContext();
    });
    $('.hide-admob').focus(function () {
        AdMob.hideBanner();
        $(this).blur(function () {
            if ($.mobile.activePage[0].id != "boardpage"){
                AdMob.showBanner();
            }
        });
    });
    $(document).on("pageshow",function(event){
        if ($.mobile.activePage[0].id === "boardpage") {
            AdMob.hideBanner();
        }else{
            $("html, body").animate({ scrollTop: $(document).height() }, "slow");
            AdMob.showBanner();
        }
    });
    //Check users setting
    var setting = (new LocalStorageManager()).getUserSetting();
    $('#guide').prop('checked', setting.guide);
    $('#sound').prop('checked', setting.sound);
    changSelect();
});
//Check is login
function checkContext() {
    if (!CONTEXT.user) {
        Logoff();
    } else {
        $('#chessBoardContainer').css({
            display: 'block'
        });
    }
}
//Share to facebook
function openFacebook(gameId) {
    window.open("https://www.facebook.com/sharer/sharer.php?u=https://play.google.com/store/apps/details?id=com.k4us.rekonline");
}
//Clear data log
function controlDataLog(players, users, waitings, playings) {
    clearTimeout(thistimeout);
    if (players) {
        $('.players').html(users);
    } else {
        $('.waitings').html(waitings);
        $('.playings').html(playings);
    }
}
//Controller new message
function controlNewMassage(ms) {
    msnotify = ms;
    //console.log("new");
    if (thiscurrentGameName.length != 0)
        return;
    clearTimeout(thistimeout);
    thiscurrentGameName = $('#boardpage_header').html();
    var counter = 0;
    clearInterval(thistitleTimerId);
    thistitleTimerId = setInterval(function () {
        text1 = "<span style=\"color:red;\">" + msnotify + "</span>";
        text2 = "<span style=\"color:white;\">" + msnotify + "</span>";
        $('#boardpage_header').html($('#boardpage_header').html() === text1 ? text2 : text1);
        counter++;
        if (counter == 5) {
            clearInterval(thistitleTimerId);
            $('#boardpage_header').html(thiscurrentGameName);
            thiscurrentGameName = "";
        }
    }, 500);
}
//When user share
function openShare() {
    if (mobile)
        window.plugins.socialsharing.share('I\'m playing it.', null, null, 'https://play.google.com/store/apps/details?id=com.k4us.rekonline');
    else
        openFacebook("");
}
//When user click update
function getupdate() {
    document.location.href = 'market://details?id=com.k4us.rekonline';
}
//Escape html
function htmlEscape(str) {
    if (typeof jQuery !== 'undefined') {
        // Create an empty div to use as a container,
        // then put the raw text in and get the HTML
        // equivalent out.
        return jQuery('<div/>').text(str).html();
    }

    // No jQuery, so use string replace.
    return str
        .replace(/&/g, '&amp;')
        .replace(/>/g, '&gt;')
        .replace(/</g, '&lt;')
        .replace(/"/g, '&quot;');
}
//When user click option sound or guide move
function changSelect() {
    CHESSBOARD.canSelect = $('#guide').prop('checked');
    CHESSBOARD.canSound = $('#sound').prop('checked');
    (new LocalStorageManager()).setUserSetting({
        guide: CHESSBOARD.canSelect, sound: CHESSBOARD.canSound
    })
}
//On focus each input text we need to check padding make sue not overlay
function toBottomPadding(e) {
    return;
    if (!mobile)
        return;
    scanFocus(e.id);
    $('#' + $.mobile.activePage[0].id).addClass("bottom_padding");
    window.scrollTo(0, document.body.scrollHeight);
}
function scanFocus(eleid) {
    if ($("#" + eleid).is(":focus")) {
        setTimeout(function () {
            scanFocus(eleid);
        }, 1000);
        return false;
    }
    $('#' + $.mobile.activePage[0].id).removeClass("bottom_padding");
}
//Surround each name by anchor tag and icon
function formName(name, target) {
    if (!name)
        return;
    var star = '';
    //on private chat
    if (name.indexOf('* ') == 0) {
        name = name.substr(2);
        star = '* ';
    }
    if (name.indexOf('fb_') == 0) {
        name = name.substr(3);
        return "<a href=\"javascript:void(0)\" class=\"chat_user\" style=\"color:#" + Color(name) + ";\" onclick=\"copyUserName('" + name + "','" + target + "');\">" + star + "<span style=\"color: #4B67A8\"><i class=\"fa fa-facebook-square\"></i></span> " + name + "</a>";
    }
    return "<a href=\"javascript:void(0)\" class=\"chat_user\" style=\"color:#" + Color(name) + ";\" onclick=\"copyUserName('" + name + "','" + target + "');\">" + star + name + "</a>";
}
//Filter name on showing board header
function nameToBoardHeader(name) {
    if (!name)
        return;
    var ficon = '';
    if (name.match(/vs fb_/g))
        name = name.replace(/vs fb_/mg, 'vs <span style="color:#4B67A8"><i class="fa fa-facebook-square"></i></span> ');
    if (name.indexOf('fb_') == 0) {
        name = name.substr(3);
        ficon = '<span style="color:#4B67A8"><i class="fa fa-facebook-square"></i></span> ';
    }
    $('#boardpage_header').html(ficon + name);
}
//Message show in chat comment have to check
function filterName(msg, target) {
    var arr = msg.split(']');
    msg = '';
    for (i in arr) {
        if (i < arr.length - 1)
            arr[i] += ']';
        msg += arr[i].replace(/@\[(.+)\]/mg, "@" + formName('$1', target) + "</a>");
    }
    return msg
}
//Make color for name
/**
 * @return {string}
 */
function Color(str) {
    if (str) {
        c = "0123456789ABCDEF";
        for (i = 0; i < 6 - (str.length < 6 ? str.length : 6); i++)
            str += 'a';
        var str_color = '';
        for (var i = 0; i < 3; i++) {
            var tmp = str.charCodeAt(i);
            str_color += c.charAt((tmp % 8) + 8);
        }
        for (i = 1; i <= 3; i++) {
            tmp = str.charCodeAt(str.length - i);
            str_color += c.charAt((tmp % 8) + 8);
        }
        return str_color;
    }
    return "FFFFFF";
}


function getUrlVar(key) {
    var result = new RegExp(key + "=([^&]*)", "i").exec(window.location.search);
    return result && unescape(result[1]) || "";
}
function SendMessage(text, channel, category, successCallBack, errorCallBack) {
    if (!CHESSINFO.user) {
        return;
    }
    if (!channel) {
        channel = 'MAIN';
    }
    if (!category) {
        category = 'chat_msg';
    }
    var data = {
        user: CHESSINFO.user,
        channel: channel,
        key: CHESSINFO.key,
        msg: text,
        category: category
    };
    socket.emit('msg', data, function (response) {
        if (response.returncode === 'no')
            errorCallBack();
        else
            successCallBack();
    });
};
function copyUserName(user, to) {
    if (user) {
        if (to === "main_chat_input")
            socket.emit('mention', {
                user: user
            });
        var input = $('#' + to);
        var caretPos = input.getCursorPosition();
        var val1 = input.val().substr(0, caretPos);
        var val2 = input.val().substr(caretPos);
        input.val(val1 + " @[" + user + "] " + val2);
        input.focus();
    }
    var len = input.val().length;
    input[0].focus();
    input[0].setSelectionRange(len, len);
}
function openTwitter(gameId) {
    var tmp = $("#boardpage_gamelink").val();
    var tmp_encoded = encodeURIComponent(tmp);
    var link = "https://play.google.com/store/apps/details?id=com.k4us.rekonline";
    window.open("https://twitter.com/intent/tweet?text=" +
        tmp_encoded +
        "&hashtags=OukOnline&url=" + link, "_blank");
}
function openFacebook(gameId) {
    window.open("https://www.facebook.com/sharer/sharer.php?u=https://play.google.com/store/apps/details?id=com.k4us.rekonline");
}
function openGoogle(gameId) {
    window.open("https://plus.google.com/share?url=https://play.google.com/store/apps/details?id=com.k4us.rekonline");
}